require 'tuya/ci/core/config/config_modules'

module TYCiCore
  class ODMConfigModules < ConfigModules

    attr_accessor :content

    def initialize(config_path="./config_modules.json", pod_path="./Pods/")
      @config_path = config_path
      @pod_path = pod_path
      @content = config_hash
    end

    def add_mix(key, value)
      mix = @content["mixMap"]
      if mix.nil? || mix.empty?
        mix = Hash[key => value]
      else
        mix[key]=value
      end
      @content["mixMap"]=mix
    end

    # def add_mix(mixHash)
    #   mix = @content["mixMap"]
    #   if mix.nil? || mix.empty?
    #     mix = mixHash
    #   else
    #     mix = mix.merge(mixHash)
    #   end
    # end

    def remove_mix(key)
      @content["mixMap"].delete(key)
    end

    def update_config(key, value)
      @content[key]=value
    end

    def setup_modules # 根据 pod目录生成 modules
      puts "ODM Setup #{@config_path} at #{@pod_path}".green

      modules = modules_in_pods

      @content["modules"] = modules
    end

    def save(target=@config_path)
      file_content = JSON.pretty_generate(@content)
      fh = File.new(target, "w")
      fh << file_content
      fh.close
    end
  end
end