module TYCiCore
	class TYDependencies

		attr_accessor :path, :content

		def initialize(path)
			@path = path
			@content = ''
		end

		def sort_pods(pods)
			if File.exist? @path
				lock_pods = analysis
				pods_hash = Hash.new
				pods.each do |pod|
					pods_hash[pod["name"]] = pod
				end
				result = []
				lock_pods.each do |lock_pod|
					if pods_hash.keys.include? lock_pod
						result.push pods_hash[lock_pod]
					end
				end
				result
			else
				puts "Can not find file: #{@path}".red
				pods
			end
		end

		def analysis
			content = File.read @path

			podfile_lock = TYPodFileLock.new content

			analysis = TYPodAnalyse.new podfile_lock
			analysis.sorted_pods
		end
	end
end