require 'tuya/ci/core/util/dir'
require 'tuya/ci/core/util/file'

module TYCiCore

	LIB_TYPE_CI = 1

	class Lib

		attr_accessor :repo
		attr_accessor :branch
		attr_accessor :project
		attr_accessor :version

		def podspec_project
			"#{@project}.podspec"
		end

		def create(type, target_path, tag, new_branch, temp)

		end

		def source(type)

			puts "Job: #{@project} version: #{@version} on :#{@branch} repo: #{@repo}".green
			build_source
		end


		private

		def build_source

			Git.git_checkout_branch branch

			podspec = PodSpec.new(podspec_project)

			if podspec.update('version', @version)

				podspec.save

				Git.git_commit_modify "feat: CI add version to #{@version}"
				Git.git_push

			end

			Git.git_tag_delete! @version if Git.git_tag_exist?(@version, true )
			Git.git_tag_add_push @version

			TYRepo::RepoTuya.new('./*.podspec').push
		end
	end
end