module TYRepo

	SPECS_ADDRESS_TUYA = 'https://code.registry.wgine.com/tuyaIOS/TYSpecs.git'
	SPECS_ADDRESS_MASTER = 'https://github.com/CocoaPods/Specs.git'
	SPECS_ADDRESS_TYUA_PUBLIC = 'https://github.com/TuyaInc/TYPublicSpecs.git'

	class Repo
		attr_accessor :podspec_path
		attr_accessor :sources
		attr_accessor :repo

		def initialize(podspec_path)
			raise 'Path cannot be nil' unless podspec_path
		end

		def command_sources
			result = ' --sources=\''
			@sources.each_with_index do |source, index|
				result << source << ((index != @sources.size - 1) ? ',':'')
			end
			result << '\''
		end

		def command
			"pod repo push #{@repo} #{@podspec_path}" << command_sources << ' --use-libraries --allow-warnings'
		end

		def push

			puts "Repo push: #{command}".green

			`#{command}`
		end

	end

	class RepoTuya < Repo

		def initialize (podspec_path)
			super podspec_path
			@sources = [TYRepo::SPECS_ADDRESS_TUYA, TYRepo::SPECS_ADDRESS_MASTER]
			@podspec_path = podspec_path
			@repo = 'TYSpecs'
		end
	end
end